Index: branches/DEV_r1879_FCM/NEMOGCM/ARCH/arch-PW6_VARGAS.fcm
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/ARCH/arch-PW6_VARGAS.fcm	(revision 1982)
+++ branches/DEV_r1879_FCM/NEMOGCM/ARCH/arch-PW6_VARGAS.fcm	(revision 1985)
@@ -1,14 +1,11 @@
 %NCDF_INC            -I/usr/local/pub/NetCDF/3.6.2/include
 %NCDF_LIB            -L /usr/local/pub/NetCDF/3.6.2/lib -lnetcdf
-%FC                  xlf_r
-%LD                  mpxlf_r
+%FC                  mpxlf90_r
+%LD                  mpxlf90_r
 %AR                  ar
 %M_K                 gmake
 %FPP_FLAGS           -P
-%FFLAGS              -qautodbl=dbl4  -O3 -qsave -qrealsize=8 -qsuffix=f=f90 -qsuffix=cpp=F90 -qextname -qsource -q64 -qlargepage -qmaxmem=-1 %NCDF_INC %USER_INC
+%FFLAGS              -O3 -qsave -qrealsize=8 -qsuffix=f=f90 -qsuffix=cpp=F90 -qextname -qsource -q64 -qlargepage -qmaxmem=-1 %NCDF_INC %USER_INC
 %MPI_FFLAGS          -I/usr/lpp/ppe.poe/include/thread64
 %OMP_FFLAGS          
-%BASE_LD              
-%MPI_LD
-%OMP_LD              
 %USER_INC
Index: branches/DEV_r1879_FCM/NEMOGCM/ARCH/arch-SX8_BRODIE.fcm
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/ARCH/arch-SX8_BRODIE.fcm	(revision 1982)
+++ branches/DEV_r1879_FCM/NEMOGCM/ARCH/arch-SX8_BRODIE.fcm	(revision 1985)
@@ -8,5 +8,3 @@
 %FPP_FLAGS          -P -traditional 
 %FFLAGS             -f2003 nocbind -dW -Wf,"-A idbl4",-ptr byte -sx8 -C vopt -Wf"-init stack=nan" -Wl"-f nan" -Wf"-P nh -O overlap" -Wf,-pvctl noassume loopcnt=10000 %NCDF_INC %USER_INC
-%BASE_LD
 %USER_INC
-
Index: branches/DEV_r1879_FCM/NEMOGCM/ARCH/arch-gfortran_osx.fcm
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/ARCH/arch-gfortran_osx.fcm	(revision 1982)
+++ branches/DEV_r1879_FCM/NEMOGCM/ARCH/arch-gfortran_osx.fcm	(revision 1985)
@@ -1,22 +1,10 @@
-
-
 %NCDF_INC            -I/usr/local/gfortran_4_3/netcdf3_6_3/include
 %NCDF_LIB            -L/usr/local/gfortran_4_3/netcdf3_6_3/lib -lnetcdf
-%COMPILER            gfortran
-%LINK                gfortran
+%FC	             gfortran
+%LD                  gfortran
 %AR                  ar
 %ARFLAGS             -rs
-%MAKE                make
-%FPP                 /usr/bin/cpp-4.0
+%M_K                 make
 %FPP_FLAGS           -P -traditional
-%FPP_DEF
-%BASE_FFLAGS          -fdefault-real-8 -O3 -funroll-all-loops  
-%PROD_FFLAGS          -fdefault-real-8 -fast
-%DEV_FFLAGS           -fdefault-real-8 -g
-%DEBUG_FFLAGS         -fdefault-real-8 -g
-%MPI_FFLAGS
-%OMP_FFLAGS
-%BASE_LD             
-%MPI_LD
-%OMP_LD
-
+%FFLAGS              -fdefault-real-8 -O3 -funroll-all-loops  
+%USER_INC
Index: branches/DEV_r1879_FCM/NEMOGCM/ARCH/arch-ifort_osx.fcm
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/ARCH/arch-ifort_osx.fcm	(revision 1982)
+++ branches/DEV_r1879_FCM/NEMOGCM/ARCH/arch-ifort_osx.fcm	(revision 1985)
@@ -1,20 +1,10 @@
 %NCDF_INC             -I/usr/local/pub/netcdf/4.0.1-ifort/include 
 %NCDF_LIB            -L /usr/local/pub/netcdf/4.0.1-ifort/lib -lnetcdf   
-%COMPILER            mpif90
-%LINK                mpif90
+%FC                  mpif90
+%LD                  mpif90
 %AR                  libtool 
 %ARFLAGS             -c -s -o
-%MAKE                make
-%FPP                 cpp
+%M_K                 make
 %FPP_FLAGS           -P -traditional -I/usr/local/pub/openmpi/1.3.3-ifort/include
-%FPP_DEF
-%BASE_FFLAGS         -r8 -O3  -traceback 
-%PROD_FFLAGS         -r8 -fast
-%DEV_FFLAGS          -r8 -g
-%DEBUG_FFLAGS        -r8 -g
-%MPI_FFLAGS
-%OMP_FFLAGS
-%BASE_LD             
-%MPI_LD
-%OMP_LD
-
+%FFLAGS 	     -r8 -O3  -traceback 
+%USER_INC
Index: branches/DEV_r1879_FCM/NEMOGCM/CONFIG/GYRE/cpp_GYRE.fcm
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/CONFIG/GYRE/cpp_GYRE.fcm	(revision 1985)
+++ branches/DEV_r1879_FCM/NEMOGCM/CONFIG/GYRE/cpp_GYRE.fcm	(revision 1985)
@@ -0,0 +1,1 @@
+ bld::tool::fppkeys key_zco key_gyre key_dynspg_flt key_ldfslp key_zdftke key_vectopt_loop key_vectopt_memory
Index: branches/DEV_r1879_FCM/NEMOGCM/CONFIG/GYRE_LOBSTER/cpp_GYRE_LOBSTER.fcm
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/CONFIG/GYRE_LOBSTER/cpp_GYRE_LOBSTER.fcm	(revision 1985)
+++ branches/DEV_r1879_FCM/NEMOGCM/CONFIG/GYRE_LOBSTER/cpp_GYRE_LOBSTER.fcm	(revision 1985)
@@ -0,0 +1,1 @@
+bld::tool::fppkeys key_zco key_gyre key_dynspg_flt key_ldfslp key_zdftke key_vectopt_loop key_vectopt_memory key_top key_lobster key_trc_diaadd key_trc_dia3d
Index: branches/DEV_r1879_FCM/NEMOGCM/CONFIG/ORCA2_LIM/cpp_ORCA2_LIM.fcm
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/CONFIG/ORCA2_LIM/cpp_ORCA2_LIM.fcm	(revision 1985)
+++ branches/DEV_r1879_FCM/NEMOGCM/CONFIG/ORCA2_LIM/cpp_ORCA2_LIM.fcm	(revision 1985)
@@ -0,0 +1,1 @@
+ bld::tool::fppkeys key_trabbl_dif key_vectopt_loop key_vectopt_memory key_orca_r2 key_lim2 key_dynspg_flt key_diaeiv key_ldfslp key_traldf_c2d key_traldf_eiv key_dynldf_c3d key_dtatem key_dtasal key_tradmp key_trabbc key_zdftke key_zdfddm key_mpp_mpi
Index: branches/DEV_r1879_FCM/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/cpp_ORCA2_LIM_PISCES.fcm
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/cpp_ORCA2_LIM_PISCES.fcm	(revision 1985)
+++ branches/DEV_r1879_FCM/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/cpp_ORCA2_LIM_PISCES.fcm	(revision 1985)
@@ -0,0 +1,1 @@
+bld::tool::fppkeys key_trabbl_dif key_vectopt_loop key_vectopt_memory key_orca_r2 key_lim2 key_dynspg_flt key_diaeiv key_ldfslp key_traldf_c2d key_traldf_eiv key_dynldf_c3d key_dtatem key_dtasal key_tradmp key_trabbc key_zdftke key_zdfddm key_top key_pisces key_trcbbl_dif key_trcldf_eiv key_trc_zdfddm key_trc_diaadd key_trc_dia3d
Index: branches/DEV_r1879_FCM/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/cpp_ORCA2_OFF_PISCES.fcm
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/cpp_ORCA2_OFF_PISCES.fcm	(revision 1985)
+++ branches/DEV_r1879_FCM/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/cpp_ORCA2_OFF_PISCES.fcm	(revision 1985)
@@ -0,0 +1,1 @@
+bld::tool::fppkeys key_trabbl_dif key_vectopt_loop key_vectopt_memory key_orca_r2 key_dynspg_flt key_ldfslp key_traldf_c2d key_traldf_eiv key_zdftke key_zdfddm key_top key_off_tra key_pisces key_trcbbl_dif key_trcldf_eiv key_trc_zdfddm key_trc_diaadd key_trc_dia3d
Index: branches/DEV_r1879_FCM/NEMOGCM/CONFIG/POMME/cpp_POMME.fcm
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/CONFIG/POMME/cpp_POMME.fcm	(revision 1985)
+++ branches/DEV_r1879_FCM/NEMOGCM/CONFIG/POMME/cpp_POMME.fcm	(revision 1985)
@@ -0,0 +1,2 @@
+ bld::tool::fppkeys P_P = key_pomme_r025 key_dynspg_flt key_zdftke key_dtatem key_dtasal key_traldf_c2d key_dynldf_c2d key_ldfslp key_obc
+
Index: branches/DEV_r1879_FCM/NEMOGCM/EXTERNAL/IOIPSL/src/def.prec
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/EXTERNAL/IOIPSL/src/def.prec	(revision 1982)
+++ 	(revision )
@@ -1,22 +1,0 @@
-MODULE defprec 
-!-
-! $Id: def.prec 386 2008-09-04 08:38:48Z bellier $
-!-
-! This software is governed by the CeCILL license
-! See IOIPSL/IOIPSL_License_CeCILL.txt
-!!--------------------------------------------------------------------
-!! The module "defprec" set default precision for computation
-!!
-!! This module should be used by every modules
-!! to keep the right precision for every variable
-!!--------------------------------------------------------------------
-!?INTEGERS of KIND 1 are not supported on all computers
-!?INTEGER,PARAMETER :: i_1=SELECTED_INT_KIND(2)
-  INTEGER,PARAMETER :: i_2=SELECTED_INT_KIND(4)
-  INTEGER,PARAMETER :: i_4=SELECTED_INT_KIND(9)
-  INTEGER,PARAMETER :: i_8=SELECTED_INT_KIND(13)
-  INTEGER,PARAMETER :: r_4=SELECTED_REAL_KIND(6,37)
-  INTEGER,PARAMETER :: r_8=SELECTED_REAL_KIND(15,307)
-  INTEGER,PARAMETER :: i_std=i_?, r_std=r_?
-!-----------------
-END MODULE defprec
Index: branches/DEV_r1879_FCM/NEMOGCM/EXTERNAL/IOIPSL/src/defprec.f90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/EXTERNAL/IOIPSL/src/defprec.f90	(revision 1985)
+++ branches/DEV_r1879_FCM/NEMOGCM/EXTERNAL/IOIPSL/src/defprec.f90	(revision 1985)
@@ -0,0 +1,22 @@
+MODULE defprec 
+!-
+! $Id: def.prec 386 2008-09-04 08:38:48Z bellier $
+!-
+! This software is governed by the CeCILL license
+! See IOIPSL/IOIPSL_License_CeCILL.txt
+!!--------------------------------------------------------------------
+!! The module "defprec" set default precision for computation
+!!
+!! This module should be used by every modules
+!! to keep the right precision for every variable
+!!--------------------------------------------------------------------
+!?INTEGERS of KIND 1 are not supported on all computers
+!?INTEGER,PARAMETER :: i_1=SELECTED_INT_KIND(2)
+  INTEGER,PARAMETER :: i_2=SELECTED_INT_KIND(4)
+  INTEGER,PARAMETER :: i_4=SELECTED_INT_KIND(9)
+  INTEGER,PARAMETER :: i_8=SELECTED_INT_KIND(13)
+  INTEGER,PARAMETER :: r_4=SELECTED_REAL_KIND(6,37)
+  INTEGER,PARAMETER :: r_8=SELECTED_REAL_KIND(15,307)
+  INTEGER,PARAMETER :: i_std=i_4, r_std=r_8
+!-----------------
+END MODULE defprec
Index: branches/DEV_r1879_FCM/NEMOGCM/TOOLS/Fmake_bld.sh
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/TOOLS/Fmake_bld.sh	(revision 1982)
+++ branches/DEV_r1879_FCM/NEMOGCM/TOOLS/Fmake_bld.sh	(revision 1985)
@@ -59,4 +59,4 @@
 [ ! -d ${2}/${1}/BLD ] && \mkdir  ${2}/${1}/BLD
 ln -sf ${2}/${1}/BLD ${CONFIG_DIR}/${1}/BLD
-#ln -sf ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm ${TOOLS_DIR}/cpp.fcm
+ln -sf ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm ${TOOLS_DIR}/cpp.fcm
 rm -f  ${CONFIG_DIR}/${NEW_CONF}/BLD/fcm.bld.lock
Index: branches/DEV_r1879_FCM/NEMOGCM/TOOLS/arch.fcm
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/TOOLS/arch.fcm	(revision 1982)
+++ 	(revision )
@@ -1,1 +1,0 @@
-link ../ARCH/arch-SX8_BRODIE.fcm
Index: branches/DEV_r1879_FCM/NEMOGCM/TOOLS/bld.cfg
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/TOOLS/bld.cfg	(revision 1982)
+++ branches/DEV_r1879_FCM/NEMOGCM/TOOLS/bld.cfg	(revision 1985)
@@ -12,5 +12,5 @@
 
 %FFLAGS                   %FFLAGS %NCDF_INC  
-%LD_FLAGS                 %BASE_LD %NCDF_LIB
+%LD_FLAGS                 %NCDF_LIB
 src::agrif                $MAIN_DIR/EXTERNAL/AGRIF/AGRIF_FILES
 src::ioipsl               $MAIN_DIR/EXTERNAL/IOIPSL/src
Index: branches/DEV_r1879_FCM/NEMOGCM/TOOLS/makenemo_fcm.sh
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/TOOLS/makenemo_fcm.sh	(revision 1982)
+++ branches/DEV_r1879_FCM/NEMOGCM/TOOLS/makenemo_fcm.sh	(revision 1985)
@@ -88,6 +88,5 @@
 #-
 #- FCM and functions location ---
-#RB Should we add fcm as a vendor ???
-#export PATH=${MAIN_DIR}/modeles/fcm/bin:$PATH
+export PATH=${MAIN_DIR}/EXTERNAL/fcm/bin:$PATH
 
 #-
@@ -149,16 +148,11 @@
 export NEMO_TDIR=${NEMO_TDIR:-$CONFIG_DIR}
 
-#-
-#- Find fcm ---
-. Fcheck_script.sh fcm || exit
-
-#-
 #- When used for the first time, choose a compiler ---
-. Fcheck_archfile.sh ${CMP_NAM} || exit
+. ${TOOLS_DIR}/Fcheck_archfile.sh ${CMP_NAM} || exit
 
 #-
 #- Choose a default configuration if needed ---
 #- ORCA2_LIM or last one used ---
-. Fcheck_config.sh ${NEW_CONF} || exit 
+. ${TOOLS_DIR}/Fcheck_config.sh ${NEW_CONF} || exit 
 
 if [ ${#NEW_CONF} -eq 0 ] ; then
@@ -166,11 +160,11 @@
 		echo "You are  installing a new configuration"
 		ind=0
-		. Fread_dir.sh OPA_SRC	YES 
-		. Fread_dir.sh LIM_SRC_2 YES 
-		. Fread_dir.sh LIM_SRC_3 NO  
-		. Fread_dir.sh TOP_SRC	NO  
-		. Fread_dir.sh C1D_SRC	YES 
-		. Fread_dir.sh NST_SRC	YES 
-		. Fread_dir.sh OFF_SRC	NO  
+		. ${TOOLS_DIR}/Fread_dir.sh OPA_SRC	YES 
+		. ${TOOLS_DIR}/Fread_dir.sh LIM_SRC_2   YES 
+		. ${TOOLS_DIR}/Fread_dir.sh LIM_SRC_3    NO  
+		. ${TOOLS_DIR}/Fread_dir.sh TOP_SRC	 NO  
+		. ${TOOLS_DIR}/Fread_dir.sh C1D_SRC	YES 
+		. ${TOOLS_DIR}/Fread_dir.sh NST_SRC	YES 
+		. ${TOOLS_DIR}/Fread_dir.sh OFF_SRC	 NO  
 		REF_CONF=ORCA2_LIM
 	elif [ ${#NEM_SUBDIR} -gt 0 ] && [ ${#REF_CONF} -eq 0 ]; then
@@ -180,8 +174,8 @@
 	elif [ ${#NEM_SUBDIR} -eq 0 ] && [ ${#REF_CONF} -gt 0 ]; then
 		echo "You are  installing a new configuration based on ${REF_CONF}"
-		Fcopy_dir.sh ${REF_CONF}  
+		${TOOLS_DIR}/Fcopy_dir.sh ${REF_CONF}  
 	fi
 	NEW_CONF=${x_n}
-    . Fmake_config.sh ${NEW_CONF} ${REF_CONF}
+    . ${TOOLS_DIR}/Fmake_config.sh ${NEW_CONF} ${REF_CONF}
 else
 	sed -e "/${NEW_CONF} /d"  ${TOOLS_DIR}/cfg.txt >  ${TOOLS_DIR}/cfg.tmp
@@ -197,14 +191,12 @@
 #- Clean links and librairies ---
 #- Creating the good links, at first on OPA_SRC ---
-. Fmake_WORK.sh ${NEW_CONF} ${TAB[*]} || exit
-
-##SF   exit
-
-. Fmake_bld.sh ${NEW_CONF}  ${NEMO_TDIR} || exit
+. ${TOOLS_DIR}/Fmake_WORK.sh ${NEW_CONF} ${TAB[*]} || exit
+
+. ${TOOLS_DIR}/Fmake_bld.sh ${NEW_CONF}  ${NEMO_TDIR} || exit
 
 #- At this stage the configuration has beeen chosen
 #- We look after agrif
 grep key_agrif ${TOOLS_DIR}/cpp.fcm && export AGRIFUSE=1
-. Fprep_agrif.sh ${NEW_CONF} ${NEMO_TDIR} || exit
+. ${TOOLS_DIR}/Fprep_agrif.sh ${NEW_CONF} ${NEMO_TDIR} || exit
 
 #-
@@ -231,5 +223,5 @@
 #-
 #- Unset variables
-Fclean_var.sh
+${TOOLS_DIR}/Fclean_var.sh
 
 